/*-----------------------------
CSVե
-------------------------------*/
#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <string.h>
#include "libpq-fe.h"

/*-----------------------------------
     
-------------------------------------
*/


typedef struct {
	unsigned char kanji1;
	unsigned char kanji2;
	unsigned char kanji3;
	unsigned char kanji4;
	unsigned char kanji5;
} KANJI;

/*-----------------------------------
     ֥롼
-------------------------------------
*/
char    *char_malloc(char *a_moto);
char    *str_dainyu(char *a_moto, char *a_saki);
int     str_nyuryoku(char *a_saki, int nagasa);
int     hzhanbetu (int kubun, unsigned char code);
char    *euc2sjis(char *a_moto);
int     jisconv(KANJI *kanjicode);

/*-----------------------------------------------
//       Хѿ
//-----------------------------------------------
*/
int     uflg;            /* Uե饰 */
char    *username;       /* 桼̾ */
int     dbflg;           /* ģ̾Ϥ */
char    *dbname;         /* ģ̾ */
int     wflg1;           /* Wե饰 */
char    *password1;      /* ѥ */
int     wflg2;           /* wե饰 */
char    *password2;      /* ѥ */
int     pflg;            /* pե饰 */
char    *port;           /* ݡ */
int     hostflg;         /* hostե饰 */
char    *hostname;       /* ѥ */
int     helpflg;         /* إץե饰*/
int     excelflg;        /* ե饰 */
int     tabflg;          /* ֥ե饰 */
int     qflg;            /* qե饰 */
char    *sql;            /* SQL */
int     sqllen;          /* SQLĹ */
char    *conninfo;       /* postgreSQL³ʸ */
int     seigyoflg;       /* 楳ɤ */
int     nofieldnameflg;  /* ե̾Фʤե饰 */
int     changebool;      /* changeboolե饰 */
int     euc2sjisflg;     /* euc2sjisե饰 */

int main(int argc,char *argv[] ) {

	/*-----------------------------------------------
	//   ѿ
	//-----------------------------------------------
	*/
	char      moji1;
	char      moji2;
	char      moji3;
	char      moji4;
	char      moji5;
	char      moji6;
	char      moji7;
	char      moji8;

	PGconn    *conn;
	PGresult  *result;
	char      *query;
	char      *kekka1;
	char      *kekka2;
	char      *onamae;
	int       cnt;
	int       cnt1;
	int       cnt2;
	int       datalen;
	char      *value;
	int       parameter_suu;

	int       max_rows;
	int       max_cols;
	int       rows;
	int       cols;
	int       nullflg;
	char      *field_name;
	int       oid;
	int       booloid;
	int       fieldoid;
	int       zenkaku_flg;
	int       eucenen;
	int       sjisenen;
	int       kaigyoari;

	/*-----------------------------------------------
	//      ѿ
	//-----------------------------------------------
	*/
	uflg=0;
	dbflg=0;
	wflg1=0;
	wflg2=0;
	pflg=0;
	hostflg=0;
	helpflg=0;
	excelflg=0;
	tabflg=0;
	qflg=0;
	kaigyoari=0;

	max_rows=0;
	max_cols=0;
	rows=0;
	cols=0;
	cnt=0;
	cnt1=0;
	cnt2=0;
	nullflg=0;
	oid=0;
	booloid=0;
	fieldoid=0;
	nofieldnameflg=0;
	changebool=0;
	zenkaku_flg=0;
	eucenen=0;
	sjisenen=0;
	euc2sjisflg=0;

	/*-----------------------------------------------
	//        ޥɥ饤
	//-----------------------------------------------
	*/
	cnt=1;
	parameter_suu=argc-1;

	while (cnt<=parameter_suu) {

		moji1=*(argv[cnt]+0);
		moji2=*(argv[cnt]+1);

		/*--------- Uޥȯ ----------*/
		if (( (moji1 == '-') && (moji2 == 'U') && cnt < parameter_suu) ) {
			username=char_malloc(argv[cnt+1]);
			uflg=1;
			cnt+=2;
			continue;
		}
		if (( (moji1 == '-') && (moji2 == 'U') && cnt==parameter_suu) ) {
			fprintf(stderr, "Set username after -U parameter.\n");
			exit(EXIT_FAILURE);
		}

		/*--------- Pޥȯ ----------*/
		if (( (moji1 == '-') && (moji2 == 'p') && cnt < parameter_suu) ) {
			port=char_malloc(argv[cnt+1]);
			pflg=1;
			cnt+=2;
			continue;
		}
		if (( (moji1 == '-') && (moji2 == 'p') && cnt==parameter_suu) ) {
			fprintf(stderr, "Set port number after -p parameter.\n");
			exit(EXIT_FAILURE);
		}

		/*--------- Qޥȯ ----------*/
		if (( (moji1 == '-') && (moji2 == 'q') && cnt < parameter_suu) ) {
			sql=char_malloc(argv[cnt+1]);
			qflg=1;
			cnt+=2;
			continue;
		}
		if (( (moji1 == '-') && (moji2 == 'p') && cnt==parameter_suu) ) {
			fprintf(stderr, "Set SQL statement after -q parameter.\n");
			exit(EXIT_FAILURE);
		}

		/*--------- helpޥȯ ----------*/
		if (strcmp(argv[cnt],"--help")==0 || strcmp(argv[cnt],"--HELP")==0 ) {
			helpflg=1;
			cnt++;
			continue;
		}

		/*--------- wޥȯ ----------*/
		if (( (moji1 == '-') && (moji2 == 'w') && cnt < parameter_suu) ) {
			password1=char_malloc(argv[cnt+1]);
			wflg1=1;
			cnt+=2;
			continue;
		}
		if (( (moji1 == '-') && (moji2 == 'w') && cnt==parameter_suu) ) {
			fprintf(stderr, "Set password after -w parameter.\n");
			exit(EXIT_FAILURE);
		}

		/*--------- Wޥȯ ----------*/
		if (( (moji1 == '-') && (moji2 == 'W')) ) {
			wflg2=1;
			cnt++;
			continue;
		}

		/*--------- hޥȯ ----------*/
		if (( (moji1 == '-') && (moji2 == 'h') && cnt < parameter_suu) ) {
			hostname=char_malloc(argv[cnt+1]);
			hostflg=1;
			cnt+=2;
			continue;
		}
		if (( (moji1 == '-') && (moji2 == 'h') && cnt==parameter_suu) ) {
			fprintf(stderr, "Set hostname after -h parameter.\n");
			exit(EXIT_FAILURE);
		}

		/*--------- tabޥȯ ----------*/
		if (strcmp(argv[cnt],"--tab")==0) {
			tabflg=1;
			cnt++;
			continue;
		}

		/*--------- nofieldnameޥȯ ----------*/
		if (strcmp(argv[cnt],"--nofieldname")==0) {
			nofieldnameflg=1;
			cnt++;
			continue;
		}

		/*--------- excelflgޥȯ ----------*/
		if (strcmp(argv[cnt],"--excel")==0) {
			excelflg=1;
			cnt++;
			continue;
		}

		/*--------- changeboolޥȯ ----------*/
		if (strcmp(argv[cnt],"--changebool=true")==0) {
			changebool=1;
			cnt++;
			continue;
		}
		if (strcmp(argv[cnt],"--changebool=1")==0) {
			changebool=2;
			cnt++;
			continue;
		}

		/*--------- eucenenޥȯ ----------*/
		if (strcmp(argv[cnt],"--eucenen")==0) {
			eucenen=1;
			cnt++;
			continue;
		}

		/*--------- sjisenenޥȯ ----------*/
		if (strcmp(argv[cnt],"--sjisenen")==0) {
			sjisenen=1;
			cnt++;
			continue;
		}

		/*--------- eus2sjisޥȯ ----------*/
		if (strcmp(argv[cnt],"--euc2sjis")==0) {
			euc2sjisflg=1;
			cnt++;
			continue;
		}

		/*ʥץ*/
		if (moji1=='-') {
			fprintf(stderr, "Invalid parameter - %s\n",argv[cnt]);
			exit(EXIT_FAILURE);
		}

		/*---------ģ̾Ǽ ----------*/
		if (dbflg==0) {
			dbname=char_malloc(argv[cnt]);
			dbflg=1;
			cnt++;
			continue;
		}

		/*ʥѥ᡼*/
		fprintf(stderr,"Invalid parameter%s\n",argv[cnt]);
		exit(EXIT_FAILURE);
	}

	/*Ф*/
	if ( helpflg==1 ) {
		fprintf(stdout,"Usage\n");
		fprintf(stdout,"pg_csv [-options] dbname -q sql [--help]\n");
		fprintf(stdout,"options:\n");
		fprintf(stdout,"-U user name\n");
		fprintf(stdout,"-w password set password\n");
		fprintf(stdout,"-W prompt to input for password\n");
		fprintf(stdout,"-p port number\n");
		fprintf(stdout,"-q \"statement\"\n");
		fprintf(stdout,"-h hostname\n");
		fprintf(stdout,"--tab use TAB code insted comma\n");
		fprintf(stdout,"--nofieldname field name do not display at 1st line\n");
		fprintf(stdout,"--changebool=true change strings for bool field (t as TRUE, f as FALSE)\n");
		fprintf(stdout,"--changebool=1 change strings for bool field (t as 1, f as 0)\n");
		fprintf(stdout,"--excel set text type for excel\n");
		fprintf(stdout,"--eucenen change back slash to double back slashes(for euc code) \n");
		fprintf(stdout,"--sjisenen change back slash to double back slashes(for sjis code) \n");
		fprintf(stdout,"--euc2sjis change euc-code to sjis-code\n");
		fprintf(stdout,"--help disply this help message\n");
		exit(EXIT_SUCCESS);
	}

	/*-w  -W νʣ*/
	if (wflg1 && wflg2){
		fprintf(stderr,"Cannot setting both -w and -W.\n");
		exit(EXIT_FAILURE);
	}

	/* ѥɤ¥ */
	if (wflg2){
		password2=getpass("Password:");   
	}

	/*ӣѣ̤ʤ顼*/
	if (!qflg){
		fprintf(stderr,"Please set -q option and SQL statement.\n");
		exit(EXIT_FAILURE);
	}

	sqllen=strlen(sql);
	if (sqllen==0) {
		fprintf(stderr,"Please set -q option and SQL statement.\n");
		exit(EXIT_FAILURE);
	}

	/*debug*/
	/*printf("user=[%s]\n",username);
	printf("password1=[%s]\n",password1);
	printf("password2=[%s]\n",password2);
	printf("hostname=[%s]\n",hostname);
	printf("dbname=[%s]\n",dbname);
	exit(0);
	*/

	/*³ʸ*/
	if (NULL == ( conninfo=malloc(5000))) {
		fprintf(stderr,"Out of memory\n");
		exit(EXIT_FAILURE);
	}
	bzero(conninfo,5000);

	/* ³ʸ  */
	if (hostflg){
		strcat(conninfo,"host=");
		strcat(conninfo,hostname);
		strcat(conninfo," ");
	}

	if (dbflg){
		strcat(conninfo,"dbname=");
		strcat(conninfo,dbname);
		strcat(conninfo," ");
	}

	if (uflg){
		strcat(conninfo,"user=");
		strcat(conninfo,username);
		strcat(conninfo," ");
	}

	if (wflg1){
		strcat(conninfo,"password=");
		strcat(conninfo,password1);
		strcat(conninfo," ");
	}
	
	if (wflg2){
		strcat(conninfo,"password=");
		strcat(conninfo,password2);
		strcat(conninfo," ");
	}

	if (pflg){
		strcat(conninfo,"port=");
		strcat(conninfo,port);
		strcat(conninfo," ");
	}

	/*
	printf("conninfo=[%s]\n",conninfo);
	exit(0);
	*/

	/*ͥ*/
	conn = PQconnectdb(conninfo);

	/*ͥ*/
	if (PQstatus(conn) != CONNECTION_OK) {
		fprintf(stderr, "%s˥ͥȼ \n", PQdb(conn));
		fprintf(stderr, "%s", PQerrorMessage(conn));
		exit(EXIT_FAILURE);
	}

	/*printf("sql=[%s]\n",sql);*/

	/*եɥ׼*/
	result=PQexec(conn,"select oid, typname from pg_type order by oid;");

	/*ơȥȤԤ*/
	if (PQresultStatus(result) != PGRES_TUPLES_OK) {
		fprintf(stderr,"Statement failed - %s \n", PQerrorMessage(conn));
		PQclear(result);
		PQfinish(conn);
		exit(EXIT_FAILURE);
	}
	max_rows=PQntuples(result);
	max_cols=PQnfields(result);

	//̤μФ
	for (rows=0;rows<max_rows;rows++) {
		for (cols=0;cols<max_cols;cols++) {

			/*̥μ*/
			datalen=PQgetlength(result, rows, cols);
			
			if (datalen>0) {
			
				/* ѥ꡼ */
				if (NULL==(kekka1=malloc(datalen+1))) {
					fprintf(stderr,"out of memory \n");
					PQclear(result);
					PQfinish(conn);
					exit(EXIT_FAILURE);
				}
				bzero(kekka1,datalen+1);
				
				/*ͤμ*/
				value=PQgetvalue(result,rows,cols);
				bcopy(value,kekka1,datalen);

				if (cols==0){
					oid=atoi(kekka1);
				} else {
					if (strcmp(kekka1,"bool")==0){
						booloid=oid;
					}
				}
				/*̥ꥢγ*/
				free(kekka1);
			}
		}
		
	}
	/*곫*/
	PQclear(result);

	/*ơȥȼ¹*/
	result=PQexec(conn,sql);

	/*ơȥȤԤ*/
	if (PQresultStatus(result) != PGRES_TUPLES_OK) {
		fprintf(stderr,"Statement failed - %s \n", PQerrorMessage(conn));
		PQclear(result);
		PQfinish(conn);
		exit(EXIT_FAILURE);
	}

	max_rows=PQntuples(result);
	max_cols=PQnfields(result);
	/*printf("%d%dޤ\n",rows,cols);*/

	/*ե̾μФ*/
	if (tabflg==0 && nofieldnameflg==0) {
		for (cols=0;cols<max_cols;cols++) {
			if (excelflg){
				printf("=");
			}
			field_name = PQfname(result, cols);
			printf("\"%s\"",field_name);

			if ((cols+1)!=max_cols){
				printf(",");
			} else {
				printf("\n");
			}
		}
	}

	//̤μФ
	for (rows=0;rows<max_rows;rows++) {
		for (cols=0;cols<max_cols;cols++) {

			/*̤̥뤫ɤ*/
			nullflg=PQgetisnull(result, rows, cols);

			/*եɷOIDμ*/
			fieldoid=PQftype(result, cols);

			/*̥μ*/
			datalen=PQgetlength(result, rows, cols);
			
			if (datalen>0) {
			
				/* ѥ꡼ */
				if (NULL==(kekka1=malloc(datalen+1))) {
					fprintf(stderr,"out of memory \n");
					PQclear(result);
					PQfinish(conn);
					exit(EXIT_FAILURE);
				}
				bzero(kekka1,datalen+1);
				
				/*ͤμ*/
				value=PQgetvalue(result,rows,cols);
				bcopy(value,kekka1,datalen);

				/*֥륯ȤԤ­褦ˡ̤ΣܤΥݤ*/
				if (NULL==(kekka2=malloc(datalen*2+1))) {
					fprintf(stderr,"out of memory \n");
					PQclear(result);
					PQfinish(conn);
					exit(EXIT_FAILURE);
				}
				bzero(kekka2,datalen*2+1);

				/*֥륯Ȥȱߥޡ򣲸Ĥ䤷ĤĥХåեư*/
				cnt2=0;
				kaigyoari=0;
				for (cnt1=0;cnt1<datalen;cnt1++){

					moji1 = *(kekka1+cnt1);

					//Ԥ뤫ɤ
					if (moji1==0x0d){
						kaigyoari=1;
					}
					if (moji1==0x0a){
						kaigyoari=1;
					}
					if (moji1==0x2c){
						kaigyoari=1;
					}
					
					//ãӣ֥⡼
					if (tabflg==0) {
						if ( moji1==0x22) {
							*(kekka2+cnt2)=0x22;
							*(kekka2+cnt2+1)=0x22;
							cnt2+=2;
						} else {
							*(kekka2+cnt2)=moji1;
							cnt2++;
						}
					}

					//ֶڤ⡼
					if (tabflg==1) {
						seigyoflg=0;

						/*ѤΣХܤ*/
						if (zenkaku_flg==1){
							zenkaku_flg=0;
							*(kekka2+cnt2)=moji1;
							/*եȣʣɣѴؼƤѴ*/
							cnt2++;

						} else {

							/*ѤΣХܤ*/
							if (eucenen==1){
								if (hzhanbetu(1,moji1)){
									zenkaku_flg=1;
								}
 							}
							if (sjisenen==1){
								if (hzhanbetu(0,moji1)){
									zenkaku_flg=1;
								}
 							}

							/*CR*/
							if (moji1==0x0d) {
								*(kekka2+cnt2)=0x5c;
								*(kekka2+cnt2+1)=0x72;
								cnt2+=2;
								seigyoflg=1;
							}

							/*LF*/
							if (moji1==0x0a) {
								*(kekka2+cnt2)=0x5c;
								*(kekka2+cnt2+1)=0x6e;
								cnt2+=2;
								seigyoflg=1;
							}

							/*֥*/
							if (moji1==0x09) {
								*(kekka2+cnt2)=0x5c;
								*(kekka2+cnt2+1)=0x74;
								cnt2+=2;
								seigyoflg=1;
							}

							/*ޡ*/
							if (eucenen==1 || sjisenen==1) {
								if (moji1==0x5c) {
									*(kekka2+cnt2)=0x5c;
									*(kekka2+cnt2+1)=0x5c;
									cnt2+=2;
									seigyoflg=1;
								}
							}

							/*楳ɤʤ*/
							if (seigyoflg==0){
								*(kekka2+cnt2)=moji1;
								cnt2++;
							}
						}
					}
				}

				/* boolϤ֤ */
				if (fieldoid==booloid){
					if (strcmp(kekka2,"t")==0 && changebool==1){
						kekka2=str_dainyu(kekka2,"TRUE");
					}
					if (strcmp(kekka2,"f")==0 && changebool==1){
						kekka2=str_dainyu(kekka2,"FALSE");
					}
					if (strcmp(kekka2,"t")==0 && changebool==2){
						kekka2=str_dainyu(kekka2,"1");
					}
					if (strcmp(kekka2,"f")==0 && changebool==2){
						kekka2=str_dainyu(kekka2,"0");
					}
				}

				/*SJISɤѴ*/
				if (euc2sjisflg) {
					kekka2=euc2sjis(kekka2);
				}

				/*ͤɽ*/
				if (tabflg==0){
					if (excelflg && !kaigyoari){
						printf("=");
					}
					printf("\"%s\"",kekka2);

				} else {
					printf("%s",kekka2);
				}

				/*ǽǤʤХޤ֤ɽ*/
				if ( (cols+1)!=max_cols) {
					if (tabflg==0){
						printf(",");
					} else {
						printf("\t");
					}
				}

				/*γ*/
				free(kekka1);
				free(kekka2);

			} else {

				/*̥󥰥ξ*/
				if (tabflg==0){
					if (excelflg){
						printf("=");
					}
					printf("\"\"");
				} else {
					/*ֶڤξ硢NULLʤ\NȤ*/
					if (nullflg){
						printf("\\N");
					}
				}

				/*ǽǤʤХޤ֤ɽ*/
				if ( (cols+1)!=max_cols) {
					if (tabflg==0){
						printf(",");
					} else {
						printf("\t");
					}
				}

			}
		}
		printf("\n");
	}

	/*곫*/
	PQclear(result);

	/**/
	PQfinish(conn);

	/*λ*/
	exit(EXIT_SUCCESS);
}
/*=============================================================================
//    ǻꤷꥢ塢ǻꤷꥢ
//
//    IN   char *a_moto ʸ
//         char *a_saki ʸ
//    OUT  ʸؤΥݥ󥿡
//=============================================================================
*/
char *str_dainyu(char *a_moto, char *a_saki) {

	/*ѿ*/
	int nagasa;
	char *kekka;

	/*Υꥢ*/
	free(a_moto);

	/*ꥢĹ*/
	nagasa=strlen(a_saki);

	/**/
	if (NULL == (kekka=malloc(nagasa+1))) {
		fprintf(stderr,"out of memory \n");
		exit(EXIT_FAILURE);
	}

	/*ꥢإԡ*/
	bzero(kekka,nagasa+1);
	strcpy(kekka, a_saki);

	return kekka;
}
/*=============================================================================
//  ǻꤵ줿ʸǼʬΥݤơȤ򥳥ԡ롣
//
//    IN   char *a_moto ʸ
//    OUT  ݤΥݥ󥿡
//=============================================================================
*/
char *char_malloc(char *a_moto) {

	/*ѿ*/
	int nagasa;
	char *a_saki;

	/*Ĺ¬äơNULLɤʬ䤹*/
	nagasa=strlen(a_moto);
	nagasa++;

	/**/
	if (NULL == (a_saki=malloc(nagasa))) {
		fprintf(stderr,"out of memory \n");
		exit(EXIT_FAILURE);
	}
	bzero(a_saki,nagasa);

	/*  ԡ */
	strcpy(a_saki, a_moto);
	return a_saki;
}

/*=============================================================================
//  ѤΣХܤȾѤȽ
//
//   IN: int kubun
//           0: եJIS
//           1: ţգ
//        unsigigned char code 
//           ХܤΥ饯
//
//  OUT:  0: Ⱦ
//        1: ѣʸ
//=============================================================================
*/
int hzhanbetu (int kubun, unsigned char code) {

	int hanbetu;
	hanbetu=0;

	/* եȣʣɣ */
	if (kubun==0){
		if ((code>=128 && code<=159) || code>=224){
			hanbetu=1;
		}
	}

	/* ţգ */
	if (kubun==1){
		if ((code>=161 && code<=254) || code==142){
			hanbetu=1;
		}
	}

	return hanbetu;
}

/*=============================================================================
//  ţգâӣʣɣ
//
//    IN   char *a_moto ѴʸΥݥ󥿡
//    OUT  ݤΥݥ󥿡
//         ȤΥݥ󥿡ϲޤ
//=============================================================================
*/
char *euc2sjis(char *a_moto) {

	/*ѿ*/
	int nagasa;
	char *kekka;
	int cnt;
	int cnt2;
	unsigned char moji;
	unsigned char moji1;
	unsigned char moji2;
	int zenkaku;
	KANJI kj;

	/*ꥢĹ*/
	nagasa=strlen(a_moto);

	/**/
	if (NULL == (kekka=malloc(nagasa+2))) {
		fprintf(stderr,"out of memory \n");
		exit(EXIT_FAILURE);
	}
	bzero(kekka,nagasa+2);

	zenkaku=0;
	cnt2=0;
	for (cnt=0;cnt<nagasa;cnt++){

		moji = *(a_moto+cnt);

		//ѤΣХܤ
		if (zenkaku==1){
			moji2=moji;
			zenkaku=0;

			//Ⱦѥʤʤ飱Хܤ
			if (moji1==142) {
				*(kekka+cnt2) = moji2;
				cnt2++;
				continue;
			}

			//ʣɣӥɤˤ
			moji1 = moji1 - 0x80;
			moji2 = moji2 - 0x80;

			//եȣʣɣӤˤ
			kj.kanji4 = moji1;
			kj.kanji5 = moji2;
			jisconv(&kj);
			moji1 = kj.kanji4;
			moji2 = kj.kanji5;

			*(kekka+cnt2)   = moji1;
			*(kekka+cnt2+1) = moji2;
			cnt2=cnt2+2;
			continue;
		}

		//ѤΣХܤ
		if (hzhanbetu(1,moji)){
			zenkaku=1;
			moji1=moji;
		} else {
			zenkaku=0;
			*(kekka+cnt2)=moji;
			cnt2++;
		}
	}

	/*Υꥢ*/
	free(a_moto);

	return kekka;
}

/*=============================================================================
//     JIS  SHIFT-JIS
//
//    IN   KANJI kanjicode
//    OUT  1:Ѵ  0:Ѵ
//=============================================================================

*/
int jisconv(KANJI *kanjicode) {

	int much;
	unsigned char moji1;
	unsigned char moji2;

	much=0;
	moji1 = (unsigned char) kanjicode->kanji4;
	moji2 = (unsigned char) kanjicode->kanji5;

	/* ̥ХȤ */
	if ((moji1&1)==0){
		/*---- ----*/
		moji2+=0x7e;
		moji1--;
	} else {
		/*---- ----*/
		moji2+=0x1f;
		if (moji2>=0x7f) {
			moji2++;
		}
	}

	moji1-=0x1f;
	moji1>>=1;
	moji1+=0x80;

	if (moji1>=0xa0) {
		moji1+=0x40;
	}

	much=1;
	kanjicode->kanji4=moji1;
	kanjicode->kanji5=moji2;

	return much;
}
